package eu.datavaults.rdf

import org.apache.jena.riot.RDFFormat
import org.junit.jupiter.api.Test

class AssetTest {

    @Test
    fun `Build asset from json`() {

        val jsonString = """
            {
                "category": [ "collection" ],
                "name": {
                    "en": "Some data"
                },
                "description": {
                    "de": "Sherlock Holmes gesammelte Informationen über Moriarty"
                },
                "keywords": [ "Moriarty", "Word Domination", "Insane" ],
                "license": "CC_BY_2_0",
                "price": 12.0,
                "encrypted": true,
                "anonymised": false,
                "useTPM": true
            }
        """.trimIndent()

        val asset = DataVaults.buildAsset("sherlock-holmes", jsonString)

        println(asset.asRdfString(RDFFormat.TURTLE_PRETTY))
        println(asset.extractJson())
    }

    @Test
    fun `Build real example asset`() {
        val json = """{"assetId":"765y75d2-4268-9654-l3jd-4378672864ml","dataOwnerUUID":"gg27f52e-c09d-49ee-a83b-071eb23f6d22","name":{"en":"Occupations 2, transporationsMeans 3, twitter sourced 4"},"source":"twitter","description":{"en":"Occupations 2, transporationsMeans 3, twitter sourced 4"},"keywords":["anonymised","encrypted"],"license":"CC_BYSA","price":11.0,"encrypted":true,"anonymised":true,"useTPM":true}"""
        val jsonLd = """{"@context":{"seeAlso":{"@id":"http://www.w3.org/2000/01/rdf-schema#seeAlso","@type":"@id"},"name":"http://xmlns.com/foaf/0.1/name","id":"http://rdfs.org/sioc/ns#id","email":"http://rdfs.org/sioc/ns#email","content":"http://rdfs.org/sioc/ns#content","has_creator":{"@id":"http://rdfs.org/sioc/ns#has_creator","@type":"@id"},"created":"http://purl.org/dc/terms/created","title":"http://purl.org/dc/terms/title","accessURL":{"@id":"http://www.w3.org/ns/dcat#accessURL","@type":"@id"},"distribution":{"@id":"http://www.w3.org/ns/dcat#distribution","@type":"@id"},"feed":{"@id":"http://rdfs.org/sioc/ns#feed","@type":"@id"},"creator_of":{"@id":"http://rdfs.org/sioc/ns#creator_of","@type":"@id"},"hasValueColumn":{"@id":"http://www.datavaults.eu/ns/dv#hasValueColumn","@type":"@id"},"hasKeyColumn":{"@id":"http://www.datavaults.eu/ns/dv#hasKeyColumn","@type":"@id"},"columnType":{"@id":"http://www.datavaults.eu/ns/dv#columnType","@type":"@id"},"columnHeader":{"@id":"http://www.datavaults.eu/ns/dv#columnHeader","@type":"@id"}},"@graph":[{"@id":"https://twitter.com/palmisano_elena","@type":"sioc:UserAccount","email":"-","id":"1523567107648196612","name":"Elena Palmisano","seeAlso":"https://datavaults.eu/id/user/Elena_Palmisano"},{"@id":"https://twitter.com/palmisano_elena/status/1532661719616602114","@type":"sioc:Post","created":"2022-06-03T09:53:24.000Z","content":"Altra prova","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://twitter.com/palmisano_elena/status/1532661216136548358","@type":"sioc:Post","created":"2022-06-03T09:51:24.000Z","content":"Oggi fa caldo","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://twitter.com/palmisano_elena/status/1532656453974097921","@type":"sioc:Post","created":"2022-06-03T09:32:28.000Z","content":"Ancora test per il progetto DataVaults","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://twitter.com/palmisano_elena/status/1529731517160869888","@type":"sioc:Post","created":"2022-05-26T07:49:49.000Z","content":"Altre prove sulla piattaforma DV","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://twitter.com/palmisano_elena/status/1529731318615052288","@type":"sioc:Post","created":"2022-05-26T07:49:02.000Z","content":"Oggi sono a Prato","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://twitter.com/palmisano_elena/status/1529471590571941889","@type":"sioc:Post","created":"2022-05-25T14:36:58.000Z","content":"oggi puliscono le strade","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://twitter.com/palmisano_elena/status/1529471515372273665","@type":"sioc:Post","created":"2022-05-25T14:36:40.000Z","content":"oggi fa caldo anche a Prato","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://twitter.com/palmisano_elena/status/1529469646344269824","@type":"sioc:Post","created":"2022-05-25T14:29:14.000Z","content":"Testing data search","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://twitter.com/palmisano_elena/status/1526492065634328577","@type":"sioc:Post","created":"2022-05-17T09:17:23.000Z","content":"Sta parlando Sotiris","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://twitter.com/palmisano_elena/status/1526490967615975426","@type":"sioc:Post","created":"2022-05-17T09:13:02.000Z","content":"Oggi sole a Cipro","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://twitter.com/palmisano_elena/status/1526488766482944000","@type":"sioc:Post","created":"2022-05-17T09:04:17.000Z","content":"traffico a Prato","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://twitter.com/palmisano_elena/status/1526488731200495616","@type":"sioc:Post","created":"2022-05-17T09:04:08.000Z","content":"stiamo facendo delle prove","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://twitter.com/palmisano_elena/status/1523568757188472833","@type":"sioc:Post","created":"2022-05-09T07:41:12.000Z","content":"Oggi è una bella giornata","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://twitter.com/palmisano_elena/status/1523568698917023744","@type":"sioc:Post","created":"2022-05-09T07:40:59.000Z","content":"Oggi faccio delle prove","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://datavaults.eu/set/distribution/twitter_1523567107648196612","@type":"dcat:Distribution","accessURL":"https://datavaults.eu/dist/tw_110359621270223"},{"@id":"_:c0","@type":["http://www.datavaults.eu/ns/dv#Column"],"columnHeader":[{"@value":"id"}],"columnType":[{"@id":"http://www.w3.org/2001/XMLSchema#integer"}]},{"@id":"_:c1","@type":["http://www.datavaults.eu/ns/dv#Column"],"columnHeader":[{"@value":"text"}],"columnType":[{"@id":"http://www.w3.org/2001/XMLSchema#string"}]},{"@id":"_:c2","@type":["http://www.datavaults.eu/ns/dv#Column"],"columnHeader":[{"@value":"created_at"}],"columnType":[{"@id":"http://www.w3.org/2001/XMLSchema#dateTime"}]},{"@id":"_:c3","@type":["http://www.datavaults.eu/ns/dv#Column"],"columnHeader":[{"@value":"public_metrics-retweet_count"}],"columnType":[{"@id":"http://www.w3.org/2001/XMLSchema#integer"}]},{"@id":"_:c4","@type":["http://www.datavaults.eu/ns/dv#Column"],"columnHeader":[{"@value":"public_metrics-reply_count"}],"columnType":[{"@id":"http://www.w3.org/2001/XMLSchema#integer"}]},{"@id":"_:c5","@type":["http://www.datavaults.eu/ns/dv#Column"],"columnHeader":[{"@value":"public_metrics-like_count"}],"columnType":[{"@id":"http://www.w3.org/2001/XMLSchema#integer"}]},{"@id":"_:c6","@type":["http://www.datavaults.eu/ns/dv#Column"],"columnHeader":[{"@value":"public_metrics-quote_count"}],"columnType":[{"@id":"http://www.w3.org/2001/XMLSchema#integer"}]},{"@id":"_:c7","@type":["http://www.datavaults.eu/ns/dv#Column"],"columnHeader":[{"@value":"source"}],"columnType":[{"@id":"http://www.w3.org/2001/XMLSchema#string"}]},{"@id":"_:c8","@type":["http://www.datavaults.eu/ns/dv#Column"],"columnHeader":[{"@value":"author_id"}],"columnType":[{"@id":"http://www.w3.org/2001/XMLSchema#integer"}]},{"@id":"_:c9","@type":["http://www.datavaults.eu/ns/dv#Column"],"columnHeader":[{"@value":"conversation_id"}],"columnType":[{"@id":"http://www.w3.org/2001/XMLSchema#integer"}]},{"@id":"https://datavaults.eu/set/data/twitter1523567107648196612","@type":["http://www.w3.org/ns/dcat#Dataset","http://www.datavaults.eu/ns/dv#TabularDataSet"],"distribution":"https://datavaults.eu/set/distribution/twitter_1523567107648196612","creator_of":"https://twitter.com/palmisano_elena","feed":["https://twitter.com/palmisano_elena/status/1532661719616602114","https://twitter.com/palmisano_elena/status/1532661216136548358","https://twitter.com/palmisano_elena/status/1532656453974097921","https://twitter.com/palmisano_elena/status/1529731517160869888","https://twitter.com/palmisano_elena/status/1529731318615052288","https://twitter.com/palmisano_elena/status/1529471590571941889","https://twitter.com/palmisano_elena/status/1529471515372273665","https://twitter.com/palmisano_elena/status/1529469646344269824","https://twitter.com/palmisano_elena/status/1529469574445420544","https://twitter.com/palmisano_elena/status/1529053689658462208"],"hasKeyColumn":["_:c0"],"hasValueColumn":["_:c1","_:c2","_:c3","_:c4","_:c5","_:c6","_:c7","_:c8","_:c9"]}]}"""

        val jsonMixed = """{"assetId":"986y75d2-6453-9654-ht54-4378672864nt","dataOwnerUUID":"gg27f52e-c09d-49ee-a83b-071eb23f6d22","name":{"en":"Occupations 2, transporationsMeans 3, twitter sourced 7"},"source":"twitter","description":{"en":"Occupations 2, transporationsMeans 3, twitter sourced 7"},"keywords":["anonymised","encrypted"],"license":"CC_BYSA","price":11.0,"encrypted":true,"anonymised":true,"useTPM":true,"metadata":{"@context":{"seeAlso":{"@id":"http://www.w3.org/2000/01/rdf-schema#seeAlso","@type":"@id"},"name":"http://xmlns.com/foaf/0.1/name","id":"http://rdfs.org/sioc/ns#id","email":"http://rdfs.org/sioc/ns#email","content":"http://rdfs.org/sioc/ns#content","has_creator":{"@id":"http://rdfs.org/sioc/ns#has_creator","@type":"@id"},"created":"http://purl.org/dc/terms/created","title":"http://purl.org/dc/terms/title","accessURL":{"@id":"http://www.w3.org/ns/dcat#accessURL","@type":"@id"},"distribution":{"@id":"http://www.w3.org/ns/dcat#distribution","@type":"@id"},"feed":{"@id":"http://rdfs.org/sioc/ns#feed","@type":"@id"},"creator_of":{"@id":"http://rdfs.org/sioc/ns#creator_of","@type":"@id"},"hasValueColumn":{"@id":"http://www.datavaults.eu/ns/dv#hasValueColumn","@type":"@id"},"hasKeyColumn":{"@id":"http://www.datavaults.eu/ns/dv#hasKeyColumn","@type":"@id"},"columnType":{"@id":"http://www.datavaults.eu/ns/dv#columnType","@type":"@id"},"columnHeader":{"@id":"http://www.datavaults.eu/ns/dv#columnHeader","@type":"@id"}},"@graph":[{"@id":"https://twitter.com/palmisano_elena","@type":"sioc:UserAccount","email":"-","id":"1523567107648196612","name":"Elena Palmisano","seeAlso":"https://datavaults.eu/id/user/Elena_Palmisano"},{"@id":"https://twitter.com/palmisano_elena/status/1532661719616602114","@type":"sioc:Post","created":"2022-06-03T09:53:24.000Z","content":"Altra prova","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://twitter.com/palmisano_elena/status/1532661216136548358","@type":"sioc:Post","created":"2022-06-03T09:51:24.000Z","content":"Oggi fa caldo","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://twitter.com/palmisano_elena/status/1532656453974097921","@type":"sioc:Post","created":"2022-06-03T09:32:28.000Z","content":"Ancora test per il progetto DataVaults","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://twitter.com/palmisano_elena/status/1529731517160869888","@type":"sioc:Post","created":"2022-05-26T07:49:49.000Z","content":"Altre prove sulla piattaforma DV","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://twitter.com/palmisano_elena/status/1529731318615052288","@type":"sioc:Post","created":"2022-05-26T07:49:02.000Z","content":"Oggi sono a Prato","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://twitter.com/palmisano_elena/status/1529471590571941889","@type":"sioc:Post","created":"2022-05-25T14:36:58.000Z","content":"oggi puliscono le strade","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://twitter.com/palmisano_elena/status/1529471515372273665","@type":"sioc:Post","created":"2022-05-25T14:36:40.000Z","content":"oggi fa caldo anche a Prato","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://twitter.com/palmisano_elena/status/1529469646344269824","@type":"sioc:Post","created":"2022-05-25T14:29:14.000Z","content":"Testing data search","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://twitter.com/palmisano_elena/status/1526492065634328577","@type":"sioc:Post","created":"2022-05-17T09:17:23.000Z","content":"Sta parlando Sotiris","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://twitter.com/palmisano_elena/status/1526490967615975426","@type":"sioc:Post","created":"2022-05-17T09:13:02.000Z","content":"Oggi sole a Cipro","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://twitter.com/palmisano_elena/status/1526488766482944000","@type":"sioc:Post","created":"2022-05-17T09:04:17.000Z","content":"traffico a Prato","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://twitter.com/palmisano_elena/status/1526488731200495616","@type":"sioc:Post","created":"2022-05-17T09:04:08.000Z","content":"stiamo facendo delle prove","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://twitter.com/palmisano_elena/status/1523568757188472833","@type":"sioc:Post","created":"2022-05-09T07:41:12.000Z","content":"Oggi è una bella giornata","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://twitter.com/palmisano_elena/status/1523568698917023744","@type":"sioc:Post","created":"2022-05-09T07:40:59.000Z","content":"Oggi faccio delle prove","has_creator":"https://twitter.com/palmisano_elena"},{"@id":"https://datavaults.eu/set/distribution/twitter_1523567107648196612","@type":"dcat:Distribution","accessURL":"https://datavaults.eu/dist/tw_110359621270223"},{"@id":"_:c0","@type":["http://www.datavaults.eu/ns/dv#Column"],"columnHeader":[{"@value":"id"}],"columnType":[{"@id":"http://www.w3.org/2001/XMLSchema#integer"}]},{"@id":"_:c1","@type":["http://www.datavaults.eu/ns/dv#Column"],"columnHeader":[{"@value":"text"}],"columnType":[{"@id":"http://www.w3.org/2001/XMLSchema#string"}]},{"@id":"_:c2","@type":["http://www.datavaults.eu/ns/dv#Column"],"columnHeader":[{"@value":"created_at"}],"columnType":[{"@id":"http://www.w3.org/2001/XMLSchema#dateTime"}]},{"@id":"_:c3","@type":["http://www.datavaults.eu/ns/dv#Column"],"columnHeader":[{"@value":"public_metrics-retweet_count"}],"columnType":[{"@id":"http://www.w3.org/2001/XMLSchema#integer"}]},{"@id":"_:c4","@type":["http://www.datavaults.eu/ns/dv#Column"],"columnHeader":[{"@value":"public_metrics-reply_count"}],"columnType":[{"@id":"http://www.w3.org/2001/XMLSchema#integer"}]},{"@id":"_:c5","@type":["http://www.datavaults.eu/ns/dv#Column"],"columnHeader":[{"@value":"public_metrics-like_count"}],"columnType":[{"@id":"http://www.w3.org/2001/XMLSchema#integer"}]},{"@id":"_:c6","@type":["http://www.datavaults.eu/ns/dv#Column"],"columnHeader":[{"@value":"public_metrics-quote_count"}],"columnType":[{"@id":"http://www.w3.org/2001/XMLSchema#integer"}]},{"@id":"_:c7","@type":["http://www.datavaults.eu/ns/dv#Column"],"columnHeader":[{"@value":"source"}],"columnType":[{"@id":"http://www.w3.org/2001/XMLSchema#string"}]},{"@id":"_:c8","@type":["http://www.datavaults.eu/ns/dv#Column"],"columnHeader":[{"@value":"author_id"}],"columnType":[{"@id":"http://www.w3.org/2001/XMLSchema#integer"}]},{"@id":"_:c9","@type":["http://www.datavaults.eu/ns/dv#Column"],"columnHeader":[{"@value":"conversation_id"}],"columnType":[{"@id":"http://www.w3.org/2001/XMLSchema#integer"}]},{"@id":"https://datavaults.eu/set/data/twitter1523567107648196612","@type":["http://www.w3.org/ns/dcat#Dataset","http://www.datavaults.eu/ns/dv#TabularDataSet"],"distribution":"https://datavaults.eu/set/distribution/twitter_1523567107648196612","creator_of":"https://twitter.com/palmisano_elena","feed":["https://twitter.com/palmisano_elena/status/1532661719616602114","https://twitter.com/palmisano_elena/status/1532661216136548358","https://twitter.com/palmisano_elena/status/1532656453974097921","https://twitter.com/palmisano_elena/status/1529731517160869888","https://twitter.com/palmisano_elena/status/1529731318615052288","https://twitter.com/palmisano_elena/status/1529471590571941889","https://twitter.com/palmisano_elena/status/1529471515372273665","https://twitter.com/palmisano_elena/status/1529469646344269824","https://twitter.com/palmisano_elena/status/1529469574445420544","https://twitter.com/palmisano_elena/status/1529053689658462208"],"hasKeyColumn":["_:c0"],"hasValueColumn":["_:c1","_:c2","_:c3","_:c4","_:c5","_:c6","_:c7","_:c8","_:c9"]}]}}"""

        val asset = DataVaults.buildAsset("765y75d2-4268-9654-l3jd-4378672864ml", jsonMixed)

        println(asset.extractJson())
        println(asset.asRdfString(RDFFormat.TURTLE_PRETTY))
    }

}